<?php
namespace Bushelpowered\Api\Fulfillment\Threshold\V1\Response;
        
class ThresholdResponse implements Api\Common\HasCreatedAtTimestamp, Api\Common\HasUpdatedAtTimestamp
{
    public string $id;
    public string $commodityCode;
    public string $locationId;
    public string $remarkCode;
    public ?float $minValue = null;
    public ?float $maxValue = null;
    public int $createdAt;
    public int $updatedAt;

    /**
     * @param  null  $id
     * @param  null  $commodityCode
     * @param  null  $locationId
     * @param  null  $remarkCode
     * @param  null  $minValue
     * @param  null  $maxValue
     * @param  null  $createdAt
     * @param  null  $updatedAt
     */
    public function __construct(string $id, string $commodityCode, string $locationId, string $remarkCode, ?float $minValue, ?float $maxValue, int $createdAt, int $updatedAt)
    {
        $this->id = $id;
        $this->commodityCode = $commodityCode;
        $this->locationId = $locationId;
        $this->remarkCode = $remarkCode;
        $this->minValue = $minValue;
        $this->maxValue = $maxValue;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    public function getCreatedAt(): int
    {
        return $this->createdAt;
    }
    public function getUpdatedAt(): int
    {
        return $this->updatedAt;
    }
}