<?php

namespace Bushelpowered\Api\Iam\Access\Common\V1alpha\Mixins;

class Consistency
{
    public string $type;
    private $data= null;
    private \JsonMapper $mapper;

    private $types = [
        minimizeLatency => '\Bushelpowered\Api\Common\Empty',
        atLeastAsFresh => '\Bushelpowered\Api\Iam\Access\Common\V1alpha\Mixins\ConsistencyToken',
        fullyConsistent => '\Bushelpowered\Api\Common\Empty',
    ];

    private function __constructor($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function MinimizeLatency(\Bushelpowered\Api\Common\Empty $data): Consistency
    {
        return Consistency(minimizeLatency, $data);
    }
    public static function AtLeastAsFresh(\Bushelpowered\Api\Iam\Access\Common\V1alpha\Mixins\ConsistencyToken $data): Consistency
    {
        return Consistency(atLeastAsFresh, $data);
    }
    public static function FullyConsistent(\Bushelpowered\Api\Common\Empty $data): Consistency
    {
        return Consistency(fullyConsistent, $data);
    }

    public function getData() {
        $className = $this->types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    