<?php
namespace Bushelpowered\Api\Iam\Access\Common\V1alpha;
        
class Role implements Api\Common\HasCreatedAtTimestamp, Api\Common\HasUpdatedAtTimestamp
{
    public string $id;
    public string $name;
    /** @var string[] $permissions */
    public array $permissions;
    public bool $isTenantDefined;
    public ?string $tenantId = null;
    public int $createdAt;
    public int $updatedAt;

    /**
     * @param  null  $id
     * @param  null  $name
     * @param  string[]  $permissions
     * @param  null  $isTenantDefined
     * @param  null  $tenantId
     * @param  null  $createdAt
     * @param  null  $updatedAt
     */
    public function __construct(string $id, string $name, array $permissions, bool $isTenantDefined, ?string $tenantId, int $createdAt, int $updatedAt)
    {
        $this->id = $id;
        $this->name = $name;
        $this->permissions = $permissions;
        $this->isTenantDefined = $isTenantDefined;
        $this->tenantId = $tenantId;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    public function getCreatedAt(): int
    {
        return $this->createdAt;
    }
    public function getUpdatedAt(): int
    {
        return $this->updatedAt;
    }
}