<?php
namespace Bushelpowered\Api\Iam\Access\Evaluate\V1alpha;

use \Bushelpowered\Api\Iam\Access\Evaluate\V1alpha\Request\CheckResourceRequest;
use \Bushelpowered\Api\Iam\Access\Evaluate\V1alpha\Response\CheckResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bidl\Php\Core\Builtins\UnknownError;

class CheckResource 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    public function call(CheckResourceRequest $request, $headers): CheckResponse | BadRequest | NotAuthenticated | UnknownError
    {
         return $this->client->call('api/iam/access/evaluate/v1alpha/CheckResource', $request, new CheckResourceResponseWrapper(), $headers)->response;
    }
}

class CheckResourceResponseWrapper implements \Bidl\Php\Core\BIDlResponse {

    /** @var CheckResponse | BadRequest | NotAuthenticated | UnknownError */
    public $response;

    public function __construct()
    {
        $this->mapper = new \JsonMapper();
    }
    
    public function fromJson($data) 
    {
        switch($data->type) {
          case 'api.iam.access.evaluate.v1alpha#CheckResourceSuccess':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Iam\Access\Evaluate\V1alpha\Response\CheckResponse::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#BadRequest':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotAuthenticated':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
           default: 
             $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
        }
    }
}