<?php
namespace Bushelpowered\Api\Platform\Tenant\Event;
        
class AccountRawEvent implements Api\Common\Event\Event, Api\Common\Event\RawEvent
{
    public \Bushelpowered\Api\Platform\Tenant\Event\AccountRawVersions $raw;
    public string $idempotencyKey;
    public int $eventCreationTime;
    public ?string $tenantId = null;
    public ?string $deleteIntegrationId = null;

    /**
     * @param  null  $raw
     * @param  null  $idempotencyKey
     * @param  null  $eventCreationTime
     * @param  null  $tenantId
     * @param  null  $deleteIntegrationId
     */
    public function __construct(\Bushelpowered\Api\Platform\Tenant\Event\AccountRawVersions $raw, string $idempotencyKey, int $eventCreationTime, ?string $tenantId, ?string $deleteIntegrationId)
    {
        $this->raw = $raw;
        $this->idempotencyKey = $idempotencyKey;
        $this->eventCreationTime = $eventCreationTime;
        $this->tenantId = $tenantId;
        $this->deleteIntegrationId = $deleteIntegrationId;
    }
    
    public function getRaw(): \Bushelpowered\Api\Platform\Tenant\Event\AccountRawVersions
    {
        return $this->raw;
    }
    public function getIdempotencyKey(): string
    {
        return $this->idempotencyKey;
    }
    public function getEventCreationTime(): int
    {
        return $this->eventCreationTime;
    }
    public function getTenantId(): ?string
    {
        return $this->tenantId;
    }
    public function getDeleteIntegrationId(): ?string
    {
        return $this->deleteIntegrationId;
    }
}