<?php
namespace Bushelpowered\Api\Platform\Tenant\V1\Event;
        
class TenantEvent implements Api\Common\Event\Event
{
    public \Bushelpowered\Api\Platform\Tenant\V1\Model\TenantStandard $data;
    public string $idempotencyKey;
    public int $eventCreationTime;
    public ?string $tenantId = null;

    /**
     * @param  null  $data
     * @param  null  $idempotencyKey
     * @param  null  $eventCreationTime
     * @param  null  $tenantId
     */
    public function __construct(\Bushelpowered\Api\Platform\Tenant\V1\Model\TenantStandard $data, string $idempotencyKey, int $eventCreationTime, ?string $tenantId)
    {
        $this->data = $data;
        $this->idempotencyKey = $idempotencyKey;
        $this->eventCreationTime = $eventCreationTime;
        $this->tenantId = $tenantId;
    }
    
    public function getIdempotencyKey(): string
    {
        return $this->idempotencyKey;
    }
    public function getEventCreationTime(): int
    {
        return $this->eventCreationTime;
    }
    public function getTenantId(): ?string
    {
        return $this->tenantId;
    }
}