<?php
namespace Bushelpowered\Api\Trade\Futures\V1;

use \Bushelpowered\Api\Common\Request\EmptyRequest;
use \Bushelpowered\Api\Trade\Futures\V1\Response\CashBidGroupOverrideListResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\ConstraintViolation;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bidl\Php\Core\Builtins\UnknownError;

class GetAllCashBidGroupOverrides 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    public function call(EmptyRequest $request, $headers): CashBidGroupOverrideListResponse | BadRequest | ConstraintViolation | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/trade/futures/v1/GetAllCashBidGroupOverrides', $request, new GetAllCashBidGroupOverridesResponseWrapper(), $headers)->response;
    }
}

class GetAllCashBidGroupOverridesResponseWrapper implements \Bidl\Php\Core\BIDlResponse {

    /** @var CashBidGroupOverrideListResponse | BadRequest | ConstraintViolation | NotAuthenticated | NotAuthorized | UnknownError */
    public $response;

    public function __construct()
    {
        $this->mapper = new \JsonMapper();
    }
    
    public function fromJson($data) 
    {
        switch($data->type) {
          case 'api.trade.futures.v1#GetAllCashBidGroupOverridesSuccess':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Trade\Futures\V1\Response\CashBidGroupOverrideListResponse::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#BadRequest':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#ConstraintViolation':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\ConstraintViolation::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotAuthenticated':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotAuthorized':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
           default: 
             $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
        }
    }
}