<?php
namespace Bushelpowered\Api\Trade\Futures\V1;

use \Bushelpowered\Api\Common\Request\SlugRequest;
use \Bushelpowered\Api\Trade\Futures\V1\Response\LocationListResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\ConstraintViolation;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bushelpowered\Api\Common\NotFound;
use \Bidl\Php\Core\Builtins\UnknownError;

class GetLocationByCompanySlug 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    public function call(SlugRequest $request, $headers): LocationListResponse | BadRequest | ConstraintViolation | NotAuthenticated | NotAuthorized | NotFound | UnknownError
    {
         return $this->client->call('api/trade/futures/v1/GetLocationByCompanySlug', $request, new GetLocationByCompanySlugResponseWrapper(), $headers)->response;
    }
}

class GetLocationByCompanySlugResponseWrapper implements \Bidl\Php\Core\BIDlResponse {

    /** @var LocationListResponse | BadRequest | ConstraintViolation | NotAuthenticated | NotAuthorized | NotFound | UnknownError */
    public $response;

    public function __construct()
    {
        $this->mapper = new \JsonMapper();
    }
    
    public function fromJson($data) 
    {
        switch($data->type) {
          case 'api.trade.futures.v1#GetLocationByCompanySlugSuccess':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Trade\Futures\V1\Response\LocationListResponse::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#BadRequest':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#ConstraintViolation':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\ConstraintViolation::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotAuthenticated':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotAuthorized':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotFound':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotFound::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
           default: 
             $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
        }
    }
}